Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxgcops.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxgcops.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxgcops.c
@@ -44,6 +44,7 @@
 #include "dmxgcops.h"
 #include "dmxwindow.h"
 #include "dmxpixmap.h"
+#include "dmxlog.h"
 
 #include "mi.h"
 #include "gcstruct.h"
@@ -52,6 +53,13 @@
 
 #include "panoramiXsrv.h"
 
+#include <xcb/xcb_image.h>
+
+/* hm, conflicting definition of xcb_popcount in xcbext.h and xcb_bitops.h */
+#define xcb_popcount xcb_popcount2
+#include <xcb/xcb_bitops.h>
+#undef xcb_popcount
+
 #define DMX_GCOPS_SET_DRAWABLE(_pDraw, _draw)				\
 do {									\
     if ((_pDraw)->type == DRAWABLE_WINDOW) {				\
@@ -67,26 +75,11 @@ do {									\
 
 #define DMX_GCOPS_OFFSCREEN(_pDraw)					\
     (!dmxScreens[(_pDraw)->pScreen->myNum].beDisplay ||			\
-     (dmxOffScreenOpt &&						\
-      (_pDraw)->type == DRAWABLE_WINDOW &&				\
-      (DMX_GET_WINDOW_PRIV((WindowPtr)(_pDraw))->offscreen ||		\
-       !DMX_GET_WINDOW_PRIV((WindowPtr)(_pDraw))->window)))
-
-/** Fill spans -- this function should never be called. */
-void dmxFillSpans(DrawablePtr pDrawable, GCPtr pGC,
-		  int nInit, DDXPointPtr pptInit, int *pwidthInit,
-		  int fSorted)
-{
-    /* Error -- this should never happen! */
-}
-
-/** Set spans -- this function should never be called. */
-void dmxSetSpans(DrawablePtr pDrawable, GCPtr pGC,
-		 char *psrc, DDXPointPtr ppt, int *pwidth, int nspans,
-		 int fSorted)
-{
-    /* Error -- this should never happen! */
-}
+     (((_pDraw)->type == DRAWABLE_WINDOW) ?				\
+      ((!DMX_GET_WINDOW_PRIV((WindowPtr)(_pDraw))->window ||		\
+	(dmxOffScreenOpt &&						\
+	 DMX_GET_WINDOW_PRIV((WindowPtr)(_pDraw))->offscreen))) :	\
+      (!(DMX_GET_PIXMAP_PRIV((PixmapPtr)(_pDraw)))->pixmap)))
 
 /** Transfer \a pBits image to back-end server associated with \a
  *  pDrawable's screen.  If primitive subdivision optimization is
@@ -98,16 +91,18 @@ void dmxPutImage(DrawablePtr pDrawable,
 {
     DMXScreenInfo *dmxScreen = &dmxScreens[pDrawable->pScreen->myNum];
     dmxGCPrivPtr   pGCPriv = DMX_GET_GC_PRIV(pGC);
-    XImage        *img;
+    XImage        *img = NULL;
 
     if (DMX_GCOPS_OFFSCREEN(pDrawable)) return;
 
+    XLIB_PROLOGUE (dmxScreen);
     img = XCreateImage(dmxScreen->beDisplay,
 		       dmxScreen->beVisuals[dmxScreen->beDefVisualIndex].visual,
 		       depth, format, leftPad, pBits, w, h,
 		       BitmapPad(dmxScreen->beDisplay),
 		       (format == ZPixmap) ?
 		       PixmapBytePad(w, depth) : BitmapBytePad(w+leftPad));
+    XLIB_EPILOGUE (dmxScreen);
 
     if (img) {
 	Drawable draw;
@@ -136,6 +131,7 @@ void dmxPutImage(DrawablePtr pDrawable,
 	    nBox = REGION_NUM_RECTS(pSubImages);
 	    pBox = REGION_RECTS(pSubImages);
 
+	    XLIB_PROLOGUE (dmxScreen);
 	    while (nBox--) {
 		XPutImage(dmxScreen->beDisplay, draw, pGCPriv->gc, img,
 			  pBox->x1 - box.x1,
@@ -146,11 +142,14 @@ void dmxPutImage(DrawablePtr pDrawable,
 			  pBox->y2 - pBox->y1);
 		pBox++;
 	    }
+	    XLIB_EPILOGUE (dmxScreen);
             REGION_DESTROY(pGC->pScreen, pClip);
             REGION_DESTROY(pGC->pScreen, pSubImages);
 	} else {
+	    XLIB_PROLOGUE (dmxScreen);
 	    XPutImage(dmxScreen->beDisplay, draw, pGCPriv->gc,
 		      img, 0, 0, x, y, w, h);
+	    XLIB_EPILOGUE (dmxScreen);
 	}
 	XFree(img);             /* Use XFree instead of XDestroyImage
                                  * because pBits is passed in from the
@@ -159,6 +158,7 @@ void dmxPutImage(DrawablePtr pDrawable,
 	dmxSync(dmxScreen, FALSE);
     } else {
 	/* Error -- this should not happen! */
+	FatalError ("XCreateImage failed\n");
     }
 }
 
@@ -180,8 +180,10 @@ RegionPtr dmxCopyArea(DrawablePtr pSrc,
     DMX_GCOPS_SET_DRAWABLE(pSrc, srcDraw);
     DMX_GCOPS_SET_DRAWABLE(pDst, dstDraw);
 
+    XLIB_PROLOGUE (dmxScreen);
     XCopyArea(dmxScreen->beDisplay, srcDraw, dstDraw, pGCPriv->gc,
 	      srcx, srcy, w, h, dstx, dsty);
+    XLIB_EPILOGUE (dmxScreen);
     dmxSync(dmxScreen, FALSE);
 
     return miHandleExposures(pSrc, pDst, pGC, srcx, srcy, w, h,
@@ -207,8 +209,10 @@ RegionPtr dmxCopyPlane(DrawablePtr pSrc,
     DMX_GCOPS_SET_DRAWABLE(pSrc, srcDraw);
     DMX_GCOPS_SET_DRAWABLE(pDst, dstDraw);
 
+    XLIB_PROLOGUE (dmxScreen);
     XCopyPlane(dmxScreen->beDisplay, srcDraw, dstDraw, pGCPriv->gc,
 	       srcx, srcy, width, height, dstx, dsty, bitPlane);
+    XLIB_EPILOGUE (dmxScreen);
     dmxSync(dmxScreen, FALSE);
 
     return miHandleExposures(pSrc, pDst, pGC, srcx, srcy, width, height,
@@ -230,8 +234,10 @@ void dmxPolyPoint(DrawablePtr pDrawable,
 
     DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 
+    XLIB_PROLOGUE (dmxScreen);
     XDrawPoints(dmxScreen->beDisplay, draw, pGCPriv->gc,
 		(XPoint *)pptInit, npt, mode);
+    XLIB_EPILOGUE (dmxScreen);
     dmxSync(dmxScreen, FALSE);
 }
 
@@ -250,8 +256,10 @@ void dmxPolylines(DrawablePtr pDrawable,
 
     DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 
+    XLIB_PROLOGUE (dmxScreen);
     XDrawLines(dmxScreen->beDisplay, draw, pGCPriv->gc,
 	       (XPoint *)pptInit, npt, mode);
+    XLIB_EPILOGUE (dmxScreen);
     dmxSync(dmxScreen, FALSE);
 }
 
@@ -270,8 +278,10 @@ void dmxPolySegment(DrawablePtr pDrawabl
 
     DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 
+    XLIB_PROLOGUE (dmxScreen);
     XDrawSegments(dmxScreen->beDisplay, draw, pGCPriv->gc,
 		  (XSegment *)pSegs, nseg);
+    XLIB_EPILOGUE (dmxScreen);
     dmxSync(dmxScreen, FALSE);
 }
 
@@ -290,8 +300,10 @@ void dmxPolyRectangle(DrawablePtr pDrawa
 
     DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 
+    XLIB_PROLOGUE (dmxScreen);
     XDrawRectangles(dmxScreen->beDisplay, draw, pGCPriv->gc,
 		    (XRectangle *)pRects, nrects);
+    XLIB_EPILOGUE (dmxScreen);
 
     dmxSync(dmxScreen, FALSE);
 }
@@ -311,8 +323,10 @@ void dmxPolyArc(DrawablePtr pDrawable, G
 
     DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 
+    XLIB_PROLOGUE (dmxScreen);
     XDrawArcs(dmxScreen->beDisplay, draw, pGCPriv->gc,
 	      (XArc *)parcs, narcs);
+    XLIB_EPILOGUE (dmxScreen);
     dmxSync(dmxScreen, FALSE);
 }
 
@@ -331,8 +345,10 @@ void dmxFillPolygon(DrawablePtr pDrawabl
 
     DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 
+    XLIB_PROLOGUE (dmxScreen);
     XFillPolygon(dmxScreen->beDisplay, draw, pGCPriv->gc,
 		 (XPoint *)pPts, count, shape, mode);
+    XLIB_EPILOGUE (dmxScreen);
     dmxSync(dmxScreen, FALSE);
 }
 
@@ -351,8 +367,10 @@ void dmxPolyFillRect(DrawablePtr pDrawab
 
     DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 
+    XLIB_PROLOGUE (dmxScreen);
     XFillRectangles(dmxScreen->beDisplay, draw, pGCPriv->gc,
 		    (XRectangle *)prectInit, nrectFill);
+    XLIB_EPILOGUE (dmxScreen);
     dmxSync(dmxScreen, FALSE);
 }
 
@@ -371,8 +389,10 @@ void dmxPolyFillArc(DrawablePtr pDrawabl
 
     DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 
+    XLIB_PROLOGUE (dmxScreen);
     XFillArcs(dmxScreen->beDisplay, draw, pGCPriv->gc,
 	      (XArc *)parcs, narcs);
+    XLIB_EPILOGUE (dmxScreen);
     dmxSync(dmxScreen, FALSE);
 }
 
@@ -400,8 +420,10 @@ int dmxPolyText8(DrawablePtr pDrawable,
     if (n != 0 && !DMX_GCOPS_OFFSCREEN(pDrawable)) {
 	DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 
+	XLIB_PROLOGUE (dmxScreen);
 	XDrawString(dmxScreen->beDisplay, draw, pGCPriv->gc,
 		    x, y, chars, count);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, FALSE);
     }
 
@@ -433,8 +455,10 @@ int dmxPolyText16(DrawablePtr pDrawable,
     if (n != 0 && !DMX_GCOPS_OFFSCREEN(pDrawable)) {
 	DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 
+	XLIB_PROLOGUE (dmxScreen);
 	XDrawString16(dmxScreen->beDisplay, draw, pGCPriv->gc,
 		      x, y, (XChar2b *)chars, count);
+	XLIB_EPILOGUE (dmxScreen);
 	dmxSync(dmxScreen, FALSE);
     }
 
@@ -456,8 +480,10 @@ void dmxImageText8(DrawablePtr pDrawable
 
     DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 
+    XLIB_PROLOGUE (dmxScreen);
     XDrawImageString(dmxScreen->beDisplay, draw, pGCPriv->gc,
 		     x, y, chars, count);
+    XLIB_EPILOGUE (dmxScreen);
     dmxSync(dmxScreen, FALSE);
 }
 
@@ -476,71 +502,110 @@ void dmxImageText16(DrawablePtr pDrawabl
 
     DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 
+    XLIB_PROLOGUE (dmxScreen);
     XDrawImageString16(dmxScreen->beDisplay, draw, pGCPriv->gc,
 		       x, y, (XChar2b *)chars, count);
+    XLIB_EPILOGUE (dmxScreen);
     dmxSync(dmxScreen, FALSE);
 }
 
-/** Image Glyph Blt -- this function should never be called. */
-void dmxImageGlyphBlt(DrawablePtr pDrawable, GCPtr pGC,
-		      int x, int y, unsigned int nglyph,
-		      CharInfoPtr *ppci, pointer pglyphBase)
+void dmxPushPixels(GCPtr pGC, PixmapPtr pBitmap, DrawablePtr pDst,
+		   int width, int height, int x, int y)
 {
-    /* Error -- this should never happen! */
-}
+    /* only works for solid bitmaps */
+    if (pGC->fillStyle == FillSolid)
+    {
+	DMXScreenInfo *dmxScreen = &dmxScreens[pDst->pScreen->myNum];
+	dmxGCPrivPtr  pGCPriv = DMX_GET_GC_PRIV(pGC);
+	dmxPixPrivPtr pPixPriv = DMX_GET_PIXMAP_PRIV(pBitmap);
+	Drawable      draw;
 
-/** Poly Glyph Blt -- this function should never be called. */
-void dmxPolyGlyphBlt(DrawablePtr pDrawable, GCPtr pGC,
-		     int x, int y, unsigned int nglyph,
-		     CharInfoPtr *ppci, pointer pglyphBase)
-{
-    /* Error -- this should never happen! */
-}
+	if (DMX_GCOPS_OFFSCREEN(pDst)) return;
 
-/** Push Pixels -- this function should never be called. */
-void dmxPushPixels(GCPtr pGC, PixmapPtr pBitMap, DrawablePtr pDst,
-		   int w, int h, int x, int y)
-{
-    /* Error -- this should never happen! */
+	DMX_GCOPS_SET_DRAWABLE(pDst, draw);
+
+	XLIB_PROLOGUE (dmxScreen);
+	XSetStipple (dmxScreen->beDisplay, pGCPriv->gc, pPixPriv->pixmap);
+	XSetTSOrigin (dmxScreen->beDisplay, pGCPriv->gc, x, y);
+	XSetFillStyle (dmxScreen->beDisplay, pGCPriv->gc, FillStippled);
+	XFillRectangle (dmxScreen->beDisplay, draw,
+			pGCPriv->gc, x, y, width, height);
+	XSetFillStyle (dmxScreen->beDisplay, pGCPriv->gc, FillSolid);
+	XLIB_EPILOGUE (dmxScreen);
+	dmxSync(dmxScreen, FALSE);
+    }
+    else
+    {
+	dmxLog (dmxWarning, "function dmxPushPixels fillStyle != FillSolid "
+		"not implemented\n");
+    }
 }
 
 /**********************************************************************
  * Miscellaneous drawing commands
  */
 
-/** When Xinerama is active, the client pixmaps are always obtained from
- * screen 0.  When screen 0 is detached, the pixmaps must be obtained
- * from any other screen that is not detached.  Usually, this is screen
- * 1. */
-static DMXScreenInfo *dmxFindAlternatePixmap(DrawablePtr pDrawable, XID *draw)
+static DMXScreenInfo *
+dmxGetAlternateWindow (DrawablePtr pDrawable,
+		       int         i,
+		       XID         *draw)
 {
+
 #ifdef PANORAMIX
-    PanoramiXRes  *pXinPix;
-    int           i;
-    DMXScreenInfo *dmxScreen;
+    PanoramiXRes  *pXinWin;
+    DMXScreenInfo *dmxScreen = &dmxScreens[i];
             
-    if (noPanoramiXExtension)               return NULL;
-    if (pDrawable->type != DRAWABLE_PIXMAP) return NULL;
+    if (noPanoramiXExtension) return NULL;
+    if (!dmxScreen->beDisplay) return NULL;
     
-    if (!(pXinPix = (PanoramiXRes *)LookupIDByType(pDrawable->id, XRT_PIXMAP)))
-        return NULL;
+    if ((pXinWin = (PanoramiXRes *) LookupIDByType (pDrawable->id,
+						    XRT_WINDOW)))
+    {
+	WindowPtr     pSrc;
+	dmxWinPrivPtr pSrcPriv;
+            
+	pSrc = (WindowPtr) LookupIDByType (pXinWin->info[i].id, RT_WINDOW);
+	pSrcPriv = DMX_GET_WINDOW_PRIV (pSrc);
+	if (pSrcPriv->window)
+	{
+	    *draw = pSrcPriv->window;
+	    return dmxScreen;
+	}
+    }
+#endif
 
-    for (i = 1; i < PanoramiXNumScreens; i++) {
-        dmxScreen = &dmxScreens[i];
-        if (dmxScreen->beDisplay) {
-            PixmapPtr     pSrc;
-            dmxPixPrivPtr pSrcPriv;
+    return NULL;
+}
+
+static DMXScreenInfo *
+dmxGetAlternatePixmap (DrawablePtr pDrawable,
+		       int         i,
+		       XID         *draw)
+{
+
+#ifdef PANORAMIX
+    PanoramiXRes  *pXinPix;
+    DMXScreenInfo *dmxScreen = &dmxScreens[i];
+            
+    if (noPanoramiXExtension) return NULL;
+    if (!dmxScreen->beDisplay) return NULL;
+    
+    if ((pXinPix = (PanoramiXRes *) LookupIDByType (pDrawable->id,
+						    XRT_PIXMAP)))
+    {
+	PixmapPtr     pSrc;
+	dmxPixPrivPtr pSrcPriv;
             
-            pSrc = (PixmapPtr)LookupIDByType(pXinPix->info[i].id,
-                                             RT_PIXMAP);
-            pSrcPriv = DMX_GET_PIXMAP_PRIV(pSrc);
-            if (pSrcPriv->pixmap) {
-                *draw = pSrcPriv->pixmap;
-                return dmxScreen;
-            }
-        }
+	pSrc = (PixmapPtr) LookupIDByType (pXinPix->info[i].id, RT_PIXMAP);
+	pSrcPriv = DMX_GET_PIXMAP_PRIV (pSrc);
+	if (pSrcPriv->pixmap)
+	{
+	    *draw = pSrcPriv->pixmap;
+	    return dmxScreen;
+	}
     }
 #endif
+
     return NULL;
 }
 
@@ -553,8 +618,8 @@ void dmxGetImage(DrawablePtr pDrawable,
 		 unsigned int format, unsigned long planeMask, char *pdstLine)
 {
     DMXScreenInfo *dmxScreen = &dmxScreens[pDrawable->pScreen->myNum];
-    XImage        *img;
-    Drawable       draw;
+    Drawable      draw;
+    int           i = 0;
 
     /* Cannot get image from unviewable window */
     if (pDrawable->type == DRAWABLE_WINDOW) {
@@ -569,33 +634,90 @@ void dmxGetImage(DrawablePtr pDrawable,
 		return;
 	    }
 	}
-	DMX_GCOPS_SET_DRAWABLE(&pWindow->drawable, draw);
+	DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
 	if (DMX_GCOPS_OFFSCREEN(&pWindow->drawable))
-	    return;
+	    draw = None;
     } else {
 	DMX_GCOPS_SET_DRAWABLE(pDrawable, draw);
-	if (DMX_GCOPS_OFFSCREEN(pDrawable)) {
-            /* Try to find the pixmap on a non-detached Xinerama screen */
-            dmxScreen = dmxFindAlternatePixmap(pDrawable, &draw);
-            if (!dmxScreen) return;
-        }
+	if (DMX_GCOPS_OFFSCREEN(pDrawable))
+	    draw = None;
     }
+    
+    while (i < dmxNumScreens)
+    {
+	xcb_get_image_reply_t *reply;
+
+	if (!draw)
+	{
+	    if (pDrawable->type == DRAWABLE_WINDOW)
+		dmxScreen = dmxGetAlternateWindow (pDrawable, i++, &draw);
+	    else
+		dmxScreen = dmxGetAlternatePixmap (pDrawable, i++, &draw);
 
-    img = XGetImage(dmxScreen->beDisplay, draw,
-		    sx, sy, w, h, planeMask, format);
-    if (img) {
-	int len = img->bytes_per_line * img->height;
-	memmove(pdstLine, img->data, len);
-	XDestroyImage(img);
-    }
+	    if (!dmxScreen) continue;
+	}
 
-    dmxSync(dmxScreen, FALSE);
-}
+	reply = xcb_get_image_reply (dmxScreen->connection,
+				     xcb_get_image (dmxScreen->connection,
+						    format,
+						    draw,
+						    sx, sy, w, h,
+						    planeMask),
+				     NULL);
+	if (reply)
+	{
+	    const xcb_setup_t *setup = xcb_get_setup (dmxScreen->connection);
+	    uint32_t          bytes = xcb_get_image_data_length (reply);
+	    uint8_t           *data = xcb_get_image_data (reply);
+
+	    /* based on code in xcb_image.c, Copyright (C) 2007 Bart Massey */
+	    switch (format) {
+	    case XCB_IMAGE_FORMAT_XY_PIXMAP:
+		planeMask &= xcb_mask (reply->depth);
+		if (planeMask != xcb_mask (reply->depth))
+		{
+		    uint32_t rpm = planeMask;
+		    uint8_t  *src_plane = data;
+		    uint8_t  *dst_plane = (uint8_t *) pdstLine;
+		    uint32_t scanline_pad = setup->bitmap_format_scanline_pad;
+		    uint32_t stride = xcb_roundup (w, scanline_pad) >> 3;
+		    uint32_t size = h * stride;
+		    int      i;
+
+		    if (setup->image_byte_order == XCB_IMAGE_ORDER_MSB_FIRST)
+			rpm = xcb_bit_reverse (planeMask, reply->depth);
+
+		    for (i = 0; i < reply->depth; i++)
+		    {
+			if (rpm & 1)
+			{
+			    memcpy (dst_plane, src_plane, size);
+			    src_plane += size;
+			}
+			else
+			{
+			    memset (dst_plane, 0, size);
+			}
+
+			dst_plane += size;
+		    }
+		    break;
+		}
+
+		/* fall through */
+	    case XCB_IMAGE_FORMAT_Z_PIXMAP:
+		memmove (pdstLine, data, bytes);
+	    default:
+		break;
+	    }
 
-/** Get Spans -- this function should never be called. */
-void dmxGetSpans(DrawablePtr pDrawable, int wMax,
-		 DDXPointPtr ppt, int *pwidth, int nspans,
-		 char *pdstStart)
-{
-    /* Error -- this should never happen! */
+	    free (reply);
+	    break;
+	}
+
+	if (pDrawable->type != DRAWABLE_WINDOW)
+	    break;
+
+	draw = None;
+    }
 }
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxgcops.h
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxgcops.h
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxgcops.h
@@ -37,12 +37,6 @@
 #ifndef DMXGCOPS_H
 #define DMXGCOPS_H
 
-extern void dmxFillSpans(DrawablePtr pDrawable, GCPtr pGC,
-			 int nInit, DDXPointPtr pptInit, int *pwidthInit,
-			 int fSorted);
-extern void dmxSetSpans(DrawablePtr pDrawable, GCPtr pGC,
-			char *psrc, DDXPointPtr ppt, int *pwidth, int nspans,
-			int fSorted);
 extern void dmxPutImage(DrawablePtr pDrawable, GCPtr pGC,
 			int depth, int x, int y, int w, int h,
 			int leftPad, int format, char *pBits);
@@ -76,20 +70,11 @@ extern void dmxImageText8(DrawablePtr pD
 			  int x, int y, int count, char *chars);
 extern void dmxImageText16(DrawablePtr pDrawable, GCPtr pGC,
 			   int x, int y, int count, unsigned short *chars);
-extern void dmxImageGlyphBlt(DrawablePtr pDrawable, GCPtr pGC,
-			     int x, int y, unsigned int nglyph,
-			     CharInfoPtr *ppci, pointer pglyphBase);
-extern void dmxPolyGlyphBlt(DrawablePtr pDrawable, GCPtr pGC,
-			    int x, int y, unsigned int nglyph,
-			    CharInfoPtr *ppci, pointer pglyphBase);
-extern void dmxPushPixels(GCPtr pGC, PixmapPtr pBitMap, DrawablePtr pDst,
-			  int w, int h, int x, int y);
+extern void dmxPushPixels(GCPtr pGC, PixmapPtr pBitmap, DrawablePtr pDrawable,
+			  int width, int height, int x, int y);
 
 extern void dmxGetImage(DrawablePtr pDrawable, int sx, int sy, int w, int h,
 			unsigned int format, unsigned long planeMask,
 			char *pdstLine);
-extern void dmxGetSpans(DrawablePtr pDrawable, int wMax,
-			DDXPointPtr ppt, int *pwidth, int nspans,
-			char *pdstStart);
 
 #endif /* DMXGCOPS_H */
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxgrab.c
===================================================================
--- /dev/null
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxgrab.c
@@ -0,0 +1,392 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Author: David Reveman <davidr@novell.com>
+ */
+
+#ifdef HAVE_DMX_CONFIG_H
+#include <dmx-config.h>
+#endif
+
+#include "dmx.h"
+#include "dmxinput.h"
+#include "dmxgrab.h"
+
+#include "windowstr.h"
+
+#ifdef PANORAMIX
+#include "panoramiX.h"
+#include "panoramiXsrv.h"
+#endif
+
+static int (*dmxSaveProcVector[256]) (ClientPtr);
+
+static void
+dmxGrabKeyboard (DeviceIntPtr pDev,
+		 GrabPtr      pGrab)
+{
+
+#ifdef PANORAMIX
+    PanoramiXRes *win = NULL;
+#endif
+
+    WindowPtr    pWin;
+    int          i;
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	if (!(win = (PanoramiXRes *)SecurityLookupIDByType(
+		  serverClient, pGrab->window->drawable.id, XRT_WINDOW,
+		  DixGetAttrAccess)))
+	    return;
+    }
+#endif
+
+    for (i = 0; i < dmxNumScreens; i++)
+    {
+	DMXScreenInfo *dmxScreen = &dmxScreens[i];
+
+	if (!dmxScreen->beDisplay)
+	    continue;
+
+#ifdef PANORAMIX
+	if (!noPanoramiXExtension)
+	{
+	    dixLookupWindow (&pWin,
+			     win->info[i].id,
+			     serverClient,
+			     DixGetAttrAccess);
+	}
+	else
+#endif
+
+	{
+	    pWin = pGrab->window;
+	    if (i != pWin->drawable.pScreen->myNum)
+		continue;
+	}
+
+	dmxInputGrabKeyboard (&dmxScreen->input, pDev, pWin);
+    }
+}
+
+static void
+dmxUngrabKeyboard (DeviceIntPtr pDev,
+		   GrabPtr      pGrab)
+{
+
+#ifdef PANORAMIX
+    PanoramiXRes *win = NULL;
+#endif
+
+    WindowPtr    pWin;
+    int          i;
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	if (!(win = (PanoramiXRes *)SecurityLookupIDByType(
+		  serverClient, pGrab->window->drawable.id, XRT_WINDOW,
+		  DixGetAttrAccess)))
+	    return;
+    }
+#endif
+
+    for (i = 0; i < dmxNumScreens; i++)
+    {
+	DMXScreenInfo *dmxScreen = &dmxScreens[i];
+
+	if (!dmxScreen->beDisplay)
+	    continue;
+
+#ifdef PANORAMIX
+	if (!noPanoramiXExtension)
+	{
+	    dixLookupWindow (&pWin,
+			     win->info[i].id,
+			     serverClient,
+			     DixGetAttrAccess);
+	}
+	else
+#endif
+
+	{
+	    pWin = pGrab->window;
+	    if (i != pWin->drawable.pScreen->myNum)
+		continue;
+	}
+
+	dmxInputUngrabKeyboard (&dmxScreen->input, pDev, pWin);
+    }
+}
+
+void
+dmxActivateKeyboardGrab (DeviceIntPtr pDev,
+			 GrabPtr      pGrab,
+			 TimeStamp    time,
+			 Bool         autoGrab)
+{
+    dmxDevicePrivPtr pDevPriv = DMX_GET_DEVICE_PRIV (pDev);
+
+    dmxGrabKeyboard (pDev, pGrab);
+
+    DMX_UNWRAP (ActivateGrab, pDevPriv, &pDev->deviceGrab);
+    (*pDev->deviceGrab.ActivateGrab) (pDev, pGrab, time, autoGrab);
+    DMX_WRAP (ActivateGrab, dmxActivateKeyboardGrab, pDevPriv,
+	      &pDev->deviceGrab);
+}
+
+void
+dmxDeactivateKeyboardGrab (DeviceIntPtr pDev)
+{
+    dmxDevicePrivPtr pDevPriv = DMX_GET_DEVICE_PRIV (pDev);
+    GrabPtr          pGrab = pDev->deviceGrab.grab;
+
+    /* DeactivateGrab might call ActivateGrab so make sure we ungrab here */
+    dmxUngrabKeyboard (pDev, pGrab);
+
+    DMX_UNWRAP (DeactivateGrab, pDevPriv, &pDev->deviceGrab);
+    (*pDev->deviceGrab.DeactivateGrab) (pDev);
+    DMX_WRAP (DeactivateGrab, dmxDeactivateKeyboardGrab, pDevPriv,
+	      &pDev->deviceGrab);
+}
+
+static void
+dmxGrabPointer (DeviceIntPtr pDev,
+		GrabPtr      pGrab)
+{
+
+#ifdef PANORAMIX
+    PanoramiXRes *win = NULL, *confineToWin = NULL;
+#endif
+
+    WindowPtr    pWin, pConfineTo = NULL;
+    int          i;
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	if (!(win = (PanoramiXRes *)SecurityLookupIDByType(
+		  serverClient, pGrab->window->drawable.id, XRT_WINDOW,
+		  DixGetAttrAccess)))
+	    return;
+	if (pGrab->confineTo)
+	    if (!(confineToWin = (PanoramiXRes *)SecurityLookupIDByType(
+		      serverClient, pGrab->confineTo->drawable.id,
+		      XRT_WINDOW, DixGetAttrAccess)))
+		return;
+    }
+#endif
+
+    for (i = 0; i < dmxNumScreens; i++)
+    {
+	DMXScreenInfo *dmxScreen = &dmxScreens[i];
+
+	if (!dmxScreen->beDisplay)
+	    continue;
+
+#ifdef PANORAMIX
+	if (!noPanoramiXExtension)
+	{
+	    dixLookupWindow (&pWin,
+			     win->info[i].id,
+			     serverClient,
+			     DixGetAttrAccess);
+	    if (confineToWin)
+		dixLookupWindow (&pConfineTo,
+				 confineToWin->info[i].id,
+				 serverClient,
+				 DixGetAttrAccess);
+	}
+	else
+#endif
+
+	{
+	    pWin = pGrab->window;
+	    if (i != pWin->drawable.pScreen->myNum)
+		continue;
+	}
+
+	dmxInputGrabPointer (&dmxScreen->input,
+			     pDev,
+			     pWin,
+			     pConfineTo,
+			     pGrab->cursor);
+    }
+}
+
+static void
+dmxUngrabPointer (DeviceIntPtr pDev,
+		  GrabPtr      pGrab)
+{
+
+#ifdef PANORAMIX
+    PanoramiXRes *win = NULL;
+#endif
+
+    WindowPtr    pWin;
+    int          i;
+
+#ifdef PANORAMIX
+    if (!noPanoramiXExtension)
+    {
+	if (!(win = (PanoramiXRes *)SecurityLookupIDByType(
+		  serverClient, pGrab->window->drawable.id, XRT_WINDOW,
+		  DixGetAttrAccess)))
+	    return;
+    }
+#endif
+
+    for (i = 0; i < dmxNumScreens; i++)
+    {
+	DMXScreenInfo *dmxScreen = &dmxScreens[i];
+
+	if (!dmxScreen->beDisplay)
+	    continue;
+
+#ifdef PANORAMIX
+	if (!noPanoramiXExtension)
+	{
+	    dixLookupWindow (&pWin,
+			     win->info[i].id,
+			     serverClient,
+			     DixGetAttrAccess);
+	}
+	else
+#endif
+
+	{
+	    pWin = pGrab->window;
+	    if (i != pWin->drawable.pScreen->myNum)
+		continue;
+	}
+
+	dmxInputUngrabPointer (&dmxScreen->input, pDev, pWin);
+    }
+}
+
+void
+dmxActivatePointerGrab (DeviceIntPtr pDev,
+			GrabPtr      pGrab,
+			TimeStamp    time,
+			Bool         autoGrab)
+{
+    dmxDevicePrivPtr pDevPriv = DMX_GET_DEVICE_PRIV (pDev);
+
+    dmxGrabPointer (pDev, pGrab);
+
+    DMX_UNWRAP (ActivateGrab, pDevPriv, &pDev->deviceGrab);
+    (*pDev->deviceGrab.ActivateGrab) (pDev, pGrab, time, autoGrab);
+    DMX_WRAP (ActivateGrab, dmxActivatePointerGrab, pDevPriv,
+	      &pDev->deviceGrab);
+}
+
+void
+dmxDeactivatePointerGrab (DeviceIntPtr pDev)
+{
+    dmxDevicePrivPtr pDevPriv = DMX_GET_DEVICE_PRIV (pDev);
+    GrabPtr          pGrab = pDev->deviceGrab.grab;
+
+    /* DeactivateGrab might call ActivateGrab so make sure we ungrab here */
+    dmxUngrabPointer (pDev, pGrab);
+
+    DMX_UNWRAP (DeactivateGrab, pDevPriv, &pDev->deviceGrab);
+    (*pDev->deviceGrab.DeactivateGrab) (pDev);
+    DMX_WRAP (DeactivateGrab, dmxDeactivatePointerGrab, pDevPriv,
+	      &pDev->deviceGrab);
+}
+
+Bool
+dmxActivateFakeGrab (DeviceIntPtr pDev,
+		     GrabPtr      pGrab)
+{
+    dmxDevicePrivPtr pDevPriv = DMX_GET_DEVICE_PRIV (pDev);
+
+    if (pDevPriv->fakeGrab)
+	return TRUE;
+
+    if (pDev->deviceGrab.grab)
+	return FALSE;
+
+    pDevPriv->fakeGrab = TRUE;
+
+    DMX_UNWRAP (ActivateGrab, pDevPriv, &pDev->deviceGrab);
+    (*pDev->deviceGrab.ActivateGrab) (pDev, pGrab, currentTime, FALSE);
+    DMX_WRAP (ActivateGrab, dmxActivatePointerGrab, pDevPriv,
+	      &pDev->deviceGrab);
+
+    return TRUE;
+}
+
+void
+dmxDeactivateFakeGrab (DeviceIntPtr pDev)
+{
+    dmxDevicePrivPtr pDevPriv = DMX_GET_DEVICE_PRIV (pDev);
+
+    if (!pDevPriv->fakeGrab)
+	return;
+
+    pDevPriv->fakeGrab = FALSE;
+
+    DMX_UNWRAP (DeactivateGrab, pDevPriv, &pDev->deviceGrab);
+    (*pDev->deviceGrab.DeactivateGrab) (pDev);
+    DMX_WRAP (DeactivateGrab, dmxDeactivatePointerGrab, pDevPriv,
+	      &pDev->deviceGrab);
+}
+
+static int
+dmxProcChangeActivePointerGrab (ClientPtr client)
+{
+    DeviceIntPtr pDev;
+    GrabPtr      pGrab;
+    int          err;
+
+    err = (*dmxSaveProcVector[X_ChangeActivePointerGrab]) (client);
+    if (err != Success)
+	return err;
+
+    pDev = PickPointer (client);
+    pGrab = pDev->deviceGrab.grab;
+    if (pGrab)
+	dmxGrabPointer (pDev, pGrab);
+
+    return Success;
+}
+
+void dmxInitGrabs (void)
+{
+    int i;
+
+    for (i = 0; i < 256; i++)
+	dmxSaveProcVector[i] = ProcVector[i];
+
+    ProcVector[X_ChangeActivePointerGrab] = dmxProcChangeActivePointerGrab;
+}
+
+void dmxResetGrabs (void)
+{
+    int  i;
+
+    for (i = 0; i < 256; i++)
+	ProcVector[i] = dmxSaveProcVector[i];
+}
Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxgrab.h
===================================================================
--- /dev/null
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxgrab.h
@@ -0,0 +1,50 @@
+/*
+ * Copyright © 2008 Novell, Inc.
+ *
+ * Permission to use, copy, modify, distribute, and sell this software
+ * and its documentation for any purpose is hereby granted without
+ * fee, provided that the above copyright notice appear in all copies
+ * and that both that copyright notice and this permission notice
+ * appear in supporting documentation, and that the name of
+ * Novell, Inc. not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior permission.
+ * Novell, Inc. makes no representations about the suitability of this
+ * software for any purpose. It is provided "as is" without express or
+ * implied warranty.
+ *
+ * NOVELL, INC. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN
+ * NO EVENT SHALL NOVELL, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
+ * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
+ * OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
+ * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
+ * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * Author: David Reveman <davidr@novell.com>
+ */
+
+#ifndef DMXGRAB_H
+#define DMXGRAB_H
+
+#include "dmxinput.h"
+
+extern void dmxActivateKeyboardGrab (DeviceIntPtr pDev,
+				     GrabPtr      pGrab,
+				     TimeStamp    time,
+				     Bool         autoGrab);
+extern void dmxDeactivateKeyboardGrab (DeviceIntPtr pDev);
+
+extern void dmxActivatePointerGrab (DeviceIntPtr pDev,
+				    GrabPtr      pGrab,
+				    TimeStamp    time,
+				    Bool         autoGrab);
+extern void dmxDeactivatePointerGrab (DeviceIntPtr pDev);
+
+extern Bool dmxActivateFakeGrab (DeviceIntPtr pDev,
+				 GrabPtr      pGrab);
+extern void dmxDeactivateFakeGrab (DeviceIntPtr pDev);
+
+extern void dmxInitGrabs (void);
+extern void dmxResetGrabs (void);
+
+#endif /* DMXGRAB_H */
